package main

func Gen(out chan<- int) {
	out <- 2
	// note the missing guard!
	for i := 3; ; i = i + 2 {
		out <- i
	}
}
func Generate() (out chan int) {
	out = make(chan int)
	go Gen(out)
	return
}

func Rec(in <-chan int) {
	for i := 1; i <= 50000; i++ {
		prime := <-in // receives a prime
		println(prime, "is prime n.", i)
		in = Filter(in, prime) // install a new filter
	}
}

func Filter(in <-chan int, prime int) (out chan int) {
	out = make(chan int)
	go Fil(in,out,prime)
	return
}

func Fil(in <-chan int, out chan<- int, prime int) {
	//println("-- Filtering multiples of prime", prime)
	for i:= range in {
		if i%prime != 0 {
			out <- i // Send 'i' to 'out'
		} else {
			//println("--- Discard", i, "multiple of", prime)
		}
	}
}

func main() {
	Rec(Generate())
}